import Blockchain from "./blockchain";
import User from "../../user/user";
import { Account } from "../../user/account";
import Operation from "../operation";
export default class BlockchainSession {
    readonly user: User;
    readonly blockchain: Blockchain;
    constructor(user: User, blockchain: Blockchain);
    getAccountById(id: Buffer): Promise<Account>;
    getAccountsByParticipantId(id: Buffer): Promise<Account[]>;
    getAccountsByAuthDescriptorId(id: Buffer): Promise<Account[]>;
    query(name: string, params: any): Promise<any>;
    call(operation: Operation): Promise<any>;
}
