import PaymentHistoryStore from "./payment-history-store";
import PaymentHistoryIterator from "./payment-history-iterator";
import PaymentHistoryEntry from "./payment-history-entry";
export default class PaymentHistoryStoreLocalStorage implements PaymentHistoryStore {
    private entriesCache;
    getCount(blockchainId: Buffer, accountId: Buffer): number;
    getIterator(blockchainId: Buffer, accountId: Buffer, pageSize: number): PaymentHistoryIterator;
    save(blockchainId: Buffer, accountId: Buffer, paymentHistoryEntries: PaymentHistoryEntry[]): void;
    get(blockchainId: Buffer, accounId: Buffer, start: number, pageSize: number): PaymentHistoryEntry[];
    getSyncInfo(blockchainId: Buffer, accountId: Buffer): any;
    saveSyncInfo(blockchainId: Buffer, accountId: Buffer, syncInfo: any): void;
    private getEntriesFor;
    private paymentHistoryKey;
    private syncInfoKey;
    private loadFromStore;
    private saveToStore;
    private mapToPaymentHistoryEntry;
    deletePaymentHistory(accountId: Buffer, blockchainId?: Buffer): void;
}
