import TransferOperation from "./transfer-operation";
import XTransferOperation from "./xtransfer-operation";
import PaymentParam from "./payment-param";
export default class PaymentOperation {
    readonly inputs: PaymentParam[];
    readonly outputs: PaymentParam[];
    constructor(inputs: PaymentParam[], outputs: PaymentParam[]);
    hasInputOrOutputWithChainAndAccount(chainId: string, accountId: string): boolean;
    inputsWithChainAndAccount(chainId: string, accountId: string): PaymentParam[];
    outputsWithChainAndAccount(chainId: string, accountId: string): PaymentParam[];
    inputsWithAsset(assetId: string): PaymentParam[];
    outputsWithAsset(assetId: string): PaymentParam[];
    static fromTransfer(transfer: TransferOperation, chainId: string): PaymentOperation;
    static fromXTransfer(transfer: XTransferOperation, sourceChainId: string): PaymentOperation;
}
