"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var postchain_client_1 = require("postchain-client");
var transfer_operation_1 = require("./payment-history/payment-operation/transfer-operation");
var xtransfer_operation_1 = require("./payment-history/payment-operation/xtransfer-operation");
var payment_operation_1 = require("./payment-history/payment-operation/payment-operation");
var PaymentOperationExtractor = /** @class */ (function () {
    function PaymentOperationExtractor(rawTransaction, chainId) {
        this.transaction = rawTransaction;
        this.chainId = chainId;
    }
    PaymentOperationExtractor.prototype.extract = function () {
        var _this = this;
        var transaction = postchain_client_1.gtx.deserialize(this.transaction);
        var transfers = transaction.operations.filter(function (_a) {
            var opName = _a.opName;
            return opName === 'ft3.transfer' || opName === 'ft3.xc.init_xfer';
        });
        return transfers.map(function (transfer) {
            switch (transfer.opName) {
                case 'ft3.transfer':
                    return payment_operation_1.default.fromTransfer(transfer_operation_1.default.from(transfer), _this.chainId);
                case 'ft3.xc.init_xfer':
                    return payment_operation_1.default.fromXTransfer(xtransfer_operation_1.default.from(transfer), _this.chainId);
                default: return null;
            }
        }).filter(function (transfer) { return transfer; });
    };
    return PaymentOperationExtractor;
}());
exports.default = PaymentOperationExtractor;
//# sourceMappingURL=payment-operation-extractor.js.map