import { Account } from '../account';
import Blockchain from '../../core/blockchain/blockchain';
import User from '../user';
import SSOStore from './sso-store';
export default class SSO {
    readonly blockchain: Blockchain;
    readonly store: SSOStore;
    constructor(blockchain: Blockchain, store?: SSOStore);
    static vaultUrl: string;
    private getAccountAndUserByStoredIds;
    autoLogin(): Promise<[Account, User]>;
    initiateLogin(successUrl: string, cancelUrl: string): void;
    finalizeLogin(tx: string): Promise<[Account, User]>;
    logout(): Promise<void>;
}
